package com.generalnegentropics.archis;

//
// Archis Cellular Artificial Life Simulator
// Copyright (C) 2001-2003  Adam Ierymenko
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

/**
 * A simulation observer is an object that will be notified when each clock
 * tick cycle completes within the simulation.
 *
 * @author Adam Ierymenko
 * @version 1.0
 */

public interface SimulationObserver
{
  /**
   * Called to notify the simulation observer of a clock tick
   */
  void tick();

  /**
   * Called to notify the simulation observer of a halt
   *
   * @param haltReason Reason for halt
   */
  void halted(String haltReason);
}

