package com.generalnegentropics.archis.gui;

//
// Archis Cellular Artificial Life Simulator
// Copyright (C) 2001-2003  Adam Ierymenko
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.*;
import com.generalnegentropics.archis.*;

public class AboutBox extends JFrame
{
  private static final String LICENSE,ABOUT;
  static
  {
    StringBuffer license = new StringBuffer(131072);
    license.append("		  GNU LESSER GENERAL PUBLIC LICENSE\n");
    license.append("		       Version 2.1, February 1999\n");
    license.append("\n");
    license.append(" Copyright (C) 1991, 1999 Free Software Foundation, Inc.\n");
    license.append(" 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n");
    license.append(" Everyone is permitted to copy and distribute verbatim copies\n");
    license.append(" of this license document, but changing it is not allowed.\n");
    license.append("\n");
    license.append("[This is the first released version of the Lesser GPL.  It also counts\n");
    license.append(" as the successor of the GNU Library Public License, version 2, hence\n");
    license.append(" the version number 2.1.]\n");
    license.append("\n");
    license.append("			    Preamble\n");
    license.append("\n");
    license.append("  The licenses for most software are designed to take away your\n");
    license.append("freedom to share and change it.  By contrast, the GNU General Public\n");
    license.append("Licenses are intended to guarantee your freedom to share and change\n");
    license.append("free software--to make sure the software is free for all its users.\n");
    license.append("\n");
    license.append("  This license, the Lesser General Public License, applies to some\n");
    license.append("specially designated software packages--typically libraries--of the\n");
    license.append("Free Software Foundation and other authors who decide to use it.  You\n");
    license.append("can use it too, but we suggest you first think carefully about whether\n");
    license.append("this license or the ordinary General Public License is the better\n");
    license.append("strategy to use in any particular case, based on the explanations below.\n");
    license.append("\n");
    license.append("  When we speak of free software, we are referring to freedom of use,\n");
    license.append("not price.  Our General Public Licenses are designed to make sure that\n");
    license.append("you have the freedom to distribute copies of free software (and charge\n");
    license.append("for this service if you wish); that you receive source code or can get\n");
    license.append("it if you want it; that you can change the software and use pieces of\n");
    license.append("it in new free programs; and that you are informed that you can do\n");
    license.append("these things.\n");
    license.append("\n");
    license.append("  To protect your rights, we need to make restrictions that forbid\n");
    license.append("distributors to deny you these rights or to ask you to surrender these\n");
    license.append("rights.  These restrictions translate to certain responsibilities for\n");
    license.append("you if you distribute copies of the library or if you modify it.\n");
    license.append("\n");
    license.append("  For example, if you distribute copies of the library, whether gratis\n");
    license.append("or for a fee, you must give the recipients all the rights that we gave\n");
    license.append("you.  You must make sure that they, too, receive or can get the source\n");
    license.append("code.  If you link other code with the library, you must provide\n");
    license.append("complete object files to the recipients, so that they can relink them\n");
    license.append("with the library after making changes to the library and recompiling\n");
    license.append("it.  And you must show them these terms so they know their rights.\n");
    license.append("\n");
    license.append("  We protect your rights with a two-step method: (1) we copyright the\n");
    license.append("library, and (2) we offer you this license, which gives you legal\n");
    license.append("permission to copy, distribute and/or modify the library.\n");
    license.append("\n");
    license.append("  To protect each distributor, we want to make it very clear that\n");
    license.append("there is no warranty for the free library.  Also, if the library is\n");
    license.append("modified by someone else and passed on, the recipients should know\n");
    license.append("that what they have is not the original version, so that the original\n");
    license.append("author's reputation will not be affected by problems that might be\n");
    license.append("introduced by others.\n");
    license.append("\n");
    license.append("  Finally, software patents pose a constant threat to the existence of\n");
    license.append("any free program.  We wish to make sure that a company cannot\n");
    license.append("effectively restrict the users of a free program by obtaining a\n");
    license.append("restrictive license from a patent holder.  Therefore, we insist that\n");
    license.append("any patent license obtained for a version of the library must be\n");
    license.append("consistent with the full freedom of use specified in this license.\n");
    license.append("\n");
    license.append("  Most GNU software, including some libraries, is covered by the\n");
    license.append("ordinary GNU General Public License.  This license, the GNU Lesser\n");
    license.append("General Public License, applies to certain designated libraries, and\n");
    license.append("is quite different from the ordinary General Public License.  We use\n");
    license.append("this license for certain libraries in order to permit linking those\n");
    license.append("libraries into non-free programs.\n");
    license.append("\n");
    license.append("  When a program is linked with a library, whether statically or using\n");
    license.append("a shared library, the combination of the two is legally speaking a\n");
    license.append("combined work, a derivative of the original library.  The ordinary\n");
    license.append("General Public License therefore permits such linking only if the\n");
    license.append("entire combination fits its criteria of freedom.  The Lesser General\n");
    license.append("Public License permits more lax criteria for linking other code with\n");
    license.append("the library.\n");
    license.append("\n");
    license.append("  We call this license the \"Lesser\" General Public License because it\n");
    license.append("does Less to protect the user's freedom than the ordinary General\n");
    license.append("Public License.  It also provides other free software developers Less\n");
    license.append("of an advantage over competing non-free programs.  These disadvantages\n");
    license.append("are the reason we use the ordinary General Public License for many\n");
    license.append("libraries.  However, the Lesser license provides advantages in certain\n");
    license.append("special circumstances.\n");
    license.append("\n");
    license.append("  For example, on rare occasions, there may be a special need to\n");
    license.append("encourage the widest possible use of a certain library, so that it becomes\n");
    license.append("a de-facto standard.  To achieve this, non-free programs must be\n");
    license.append("allowed to use the library.  A more frequent case is that a free\n");
    license.append("library does the same job as widely used non-free libraries.  In this\n");
    license.append("case, there is little to gain by limiting the free library to free\n");
    license.append("software only, so we use the Lesser General Public License.\n");
    license.append("\n");
    license.append("  In other cases, permission to use a particular library in non-free\n");
    license.append("programs enables a greater number of people to use a large body of\n");
    license.append("free software.  For example, permission to use the GNU C Library in\n");
    license.append("non-free programs enables many more people to use the whole GNU\n");
    license.append("operating system, as well as its variant, the GNU/Linux operating\n");
    license.append("system.\n");
    license.append("\n");
    license.append("  Although the Lesser General Public License is Less protective of the\n");
    license.append("users' freedom, it does ensure that the user of a program that is\n");
    license.append("linked with the Library has the freedom and the wherewithal to run\n");
    license.append("that program using a modified version of the Library.\n");
    license.append("\n");
    license.append("  The precise terms and conditions for copying, distribution and\n");
    license.append("modification follow.  Pay close attention to the difference between a\n");
    license.append("\"work based on the library\" and a \"work that uses the library\".  The\n");
    license.append("former contains code derived from the library, whereas the latter must\n");
    license.append("be combined with the library in order to run.\n");
    license.append("\n");
    license.append("		  GNU LESSER GENERAL PUBLIC LICENSE\n");
    license.append("   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION\n");
    license.append("\n");
    license.append("  0. This License Agreement applies to any software library or other\n");
    license.append("program which contains a notice placed by the copyright holder or\n");
    license.append("other authorized party saying it may be distributed under the terms of\n");
    license.append("this Lesser General Public License (also called \"this License\").\n");
    license.append("Each licensee is addressed as \"you\".\n");
    license.append("\n");
    license.append("  A \"library\" means a collection of software functions and/or data\n");
    license.append("prepared so as to be conveniently linked with application programs\n");
    license.append("(which use some of those functions and data) to form executables.\n");
    license.append("\n");
    license.append("  The \"Library\", below, refers to any such software library or work\n");
    license.append("which has been distributed under these terms.  A \"work based on the\n");
    license.append("Library\" means either the Library or any derivative work under\n");
    license.append("copyright law: that is to say, a work containing the Library or a\n");
    license.append("portion of it, either verbatim or with modifications and/or translated\n");
    license.append("straightforwardly into another language.  (Hereinafter, translation is\n");
    license.append("included without limitation in the term \"modification\".)\n");
    license.append("\n");
    license.append("  \"Source code\" for a work means the preferred form of the work for\n");
    license.append("making modifications to it.  For a library, complete source code means\n");
    license.append("all the source code for all modules it contains, plus any associated\n");
    license.append("interface definition files, plus the scripts used to control compilation\n");
    license.append("and installation of the library.\n");
    license.append("\n");
    license.append("  Activities other than copying, distribution and modification are not\n");
    license.append("covered by this License; they are outside its scope.  The act of\n");
    license.append("running a program using the Library is not restricted, and output from\n");
    license.append("such a program is covered only if its contents constitute a work based\n");
    license.append("on the Library (independent of the use of the Library in a tool for\n");
    license.append("writing it).  Whether that is true depends on what the Library does\n");
    license.append("and what the program that uses the Library does.\n");
    license.append("  \n");
    license.append("  1. You may copy and distribute verbatim copies of the Library's\n");
    license.append("complete source code as you receive it, in any medium, provided that\n");
    license.append("you conspicuously and appropriately publish on each copy an\n");
    license.append("appropriate copyright notice and disclaimer of warranty; keep intact\n");
    license.append("all the notices that refer to this License and to the absence of any\n");
    license.append("warranty; and distribute a copy of this License along with the\n");
    license.append("Library.\n");
    license.append("\n");
    license.append("  You may charge a fee for the physical act of transferring a copy,\n");
    license.append("and you may at your option offer warranty protection in exchange for a\n");
    license.append("fee.\n");
    license.append("\n");
    license.append("  2. You may modify your copy or copies of the Library or any portion\n");
    license.append("of it, thus forming a work based on the Library, and copy and\n");
    license.append("distribute such modifications or work under the terms of Section 1\n");
    license.append("above, provided that you also meet all of these conditions:\n");
    license.append("\n");
    license.append("    a) The modified work must itself be a software library.\n");
    license.append("\n");
    license.append("    b) You must cause the files modified to carry prominent notices\n");
    license.append("    stating that you changed the files and the date of any change.\n");
    license.append("\n");
    license.append("    c) You must cause the whole of the work to be licensed at no\n");
    license.append("    charge to all third parties under the terms of this License.\n");
    license.append("\n");
    license.append("    d) If a facility in the modified Library refers to a function or a\n");
    license.append("    table of data to be supplied by an application program that uses\n");
    license.append("    the facility, other than as an argument passed when the facility\n");
    license.append("    is invoked, then you must make a good faith effort to ensure that,\n");
    license.append("    in the event an application does not supply such function or\n");
    license.append("    table, the facility still operates, and performs whatever part of\n");
    license.append("    its purpose remains meaningful.\n");
    license.append("\n");
    license.append("    (For example, a function in a library to compute square roots has\n");
    license.append("    a purpose that is entirely well-defined independent of the\n");
    license.append("    application.  Therefore, Subsection 2d requires that any\n");
    license.append("    application-supplied function or table used by this function must\n");
    license.append("    be optional: if the application does not supply it, the square\n");
    license.append("    root function must still compute square roots.)\n");
    license.append("\n");
    license.append("These requirements apply to the modified work as a whole.  If\n");
    license.append("identifiable sections of that work are not derived from the Library,\n");
    license.append("and can be reasonably considered independent and separate works in\n");
    license.append("themselves, then this License, and its terms, do not apply to those\n");
    license.append("sections when you distribute them as separate works.  But when you\n");
    license.append("distribute the same sections as part of a whole which is a work based\n");
    license.append("on the Library, the distribution of the whole must be on the terms of\n");
    license.append("this License, whose permissions for other licensees extend to the\n");
    license.append("entire whole, and thus to each and every part regardless of who wrote\n");
    license.append("it.\n");
    license.append("\n");
    license.append("Thus, it is not the intent of this section to claim rights or contest\n");
    license.append("your rights to work written entirely by you; rather, the intent is to\n");
    license.append("exercise the right to control the distribution of derivative or\n");
    license.append("collective works based on the Library.\n");
    license.append("\n");
    license.append("In addition, mere aggregation of another work not based on the Library\n");
    license.append("with the Library (or with a work based on the Library) on a volume of\n");
    license.append("a storage or distribution medium does not bring the other work under\n");
    license.append("the scope of this License.\n");
    license.append("\n");
    license.append("  3. You may opt to apply the terms of the ordinary GNU General Public\n");
    license.append("License instead of this License to a given copy of the Library.  To do\n");
    license.append("this, you must alter all the notices that refer to this License, so\n");
    license.append("that they refer to the ordinary GNU General Public License, version 2,\n");
    license.append("instead of to this License.  (If a newer version than version 2 of the\n");
    license.append("ordinary GNU General Public License has appeared, then you can specify\n");
    license.append("that version instead if you wish.)  Do not make any other change in\n");
    license.append("these notices.\n");
    license.append("\n");
    license.append("  Once this change is made in a given copy, it is irreversible for\n");
    license.append("that copy, so the ordinary GNU General Public License applies to all\n");
    license.append("subsequent copies and derivative works made from that copy.\n");
    license.append("\n");
    license.append("  This option is useful when you wish to copy part of the code of\n");
    license.append("the Library into a program that is not a library.\n");
    license.append("\n");
    license.append("  4. You may copy and distribute the Library (or a portion or\n");
    license.append("derivative of it, under Section 2) in object code or executable form\n");
    license.append("under the terms of Sections 1 and 2 above provided that you accompany\n");
    license.append("it with the complete corresponding machine-readable source code, which\n");
    license.append("must be distributed under the terms of Sections 1 and 2 above on a\n");
    license.append("medium customarily used for software interchange.\n");
    license.append("\n");
    license.append("  If distribution of object code is made by offering access to copy\n");
    license.append("from a designated place, then offering equivalent access to copy the\n");
    license.append("source code from the same place satisfies the requirement to\n");
    license.append("distribute the source code, even though third parties are not\n");
    license.append("compelled to copy the source along with the object code.\n");
    license.append("\n");
    license.append("  5. A program that contains no derivative of any portion of the\n");
    license.append("Library, but is designed to work with the Library by being compiled or\n");
    license.append("linked with it, is called a \"work that uses the Library\".  Such a\n");
    license.append("work, in isolation, is not a derivative work of the Library, and\n");
    license.append("therefore falls outside the scope of this License.\n");
    license.append("\n");
    license.append("  However, linking a \"work that uses the Library\" with the Library\n");
    license.append("creates an executable that is a derivative of the Library (because it\n");
    license.append("contains portions of the Library), rather than a \"work that uses the\n");
    license.append("library\".  The executable is therefore covered by this License.\n");
    license.append("Section 6 states terms for distribution of such executables.\n");
    license.append("\n");
    license.append("  When a \"work that uses the Library\" uses material from a header file\n");
    license.append("that is part of the Library, the object code for the work may be a\n");
    license.append("derivative work of the Library even though the source code is not.\n");
    license.append("Whether this is true is especially significant if the work can be\n");
    license.append("linked without the Library, or if the work is itself a library.  The\n");
    license.append("threshold for this to be true is not precisely defined by law.\n");
    license.append("\n");
    license.append("  If such an object file uses only numerical parameters, data\n");
    license.append("structure layouts and accessors, and small macros and small inline\n");
    license.append("functions (ten lines or less in length), then the use of the object\n");
    license.append("file is unrestricted, regardless of whether it is legally a derivative\n");
    license.append("work.  (Executables containing this object code plus portions of the\n");
    license.append("Library will still fall under Section 6.)\n");
    license.append("\n");
    license.append("  Otherwise, if the work is a derivative of the Library, you may\n");
    license.append("distribute the object code for the work under the terms of Section 6.\n");
    license.append("Any executables containing that work also fall under Section 6,\n");
    license.append("whether or not they are linked directly with the Library itself.\n");
    license.append("\n");
    license.append("  6. As an exception to the Sections above, you may also combine or\n");
    license.append("link a \"work that uses the Library\" with the Library to produce a\n");
    license.append("work containing portions of the Library, and distribute that work\n");
    license.append("under terms of your choice, provided that the terms permit\n");
    license.append("modification of the work for the customer's own use and reverse\n");
    license.append("engineering for debugging such modifications.\n");
    license.append("\n");
    license.append("  You must give prominent notice with each copy of the work that the\n");
    license.append("Library is used in it and that the Library and its use are covered by\n");
    license.append("this License.  You must supply a copy of this License.  If the work\n");
    license.append("during execution displays copyright notices, you must include the\n");
    license.append("copyright notice for the Library among them, as well as a reference\n");
    license.append("directing the user to the copy of this License.  Also, you must do one\n");
    license.append("of these things:\n");
    license.append("\n");
    license.append("    a) Accompany the work with the complete corresponding\n");
    license.append("    machine-readable source code for the Library including whatever\n");
    license.append("    changes were used in the work (which must be distributed under\n");
    license.append("    Sections 1 and 2 above); and, if the work is an executable linked\n");
    license.append("    with the Library, with the complete machine-readable \"work that\n");
    license.append("    uses the Library\", as object code and/or source code, so that the\n");
    license.append("    user can modify the Library and then relink to produce a modified\n");
    license.append("    executable containing the modified Library.  (It is understood\n");
    license.append("    that the user who changes the contents of definitions files in the\n");
    license.append("    Library will not necessarily be able to recompile the application\n");
    license.append("    to use the modified definitions.)\n");
    license.append("\n");
    license.append("    b) Use a suitable shared library mechanism for linking with the\n");
    license.append("    Library.  A suitable mechanism is one that (1) uses at run time a\n");
    license.append("    copy of the library already present on the user's computer system,\n");
    license.append("    rather than copying library functions into the executable, and (2)\n");
    license.append("    will operate properly with a modified version of the library, if\n");
    license.append("    the user installs one, as long as the modified version is\n");
    license.append("    interface-compatible with the version that the work was made with.\n");
    license.append("\n");
    license.append("    c) Accompany the work with a written offer, valid for at\n");
    license.append("    least three years, to give the same user the materials\n");
    license.append("    specified in Subsection 6a, above, for a charge no more\n");
    license.append("    than the cost of performing this distribution.\n");
    license.append("\n");
    license.append("    d) If distribution of the work is made by offering access to copy\n");
    license.append("    from a designated place, offer equivalent access to copy the above\n");
    license.append("    specified materials from the same place.\n");
    license.append("\n");
    license.append("    e) Verify that the user has already received a copy of these\n");
    license.append("    materials or that you have already sent this user a copy.\n");
    license.append("\n");
    license.append("  For an executable, the required form of the \"work that uses the\n");
    license.append("Library\" must include any data and utility programs needed for\n");
    license.append("reproducing the executable from it.  However, as a special exception,\n");
    license.append("the materials to be distributed need not include anything that is\n");
    license.append("normally distributed (in either source or binary form) with the major\n");
    license.append("components (compiler, kernel, and so on) of the operating system on\n");
    license.append("which the executable runs, unless that component itself accompanies\n");
    license.append("the executable.\n");
    license.append("\n");
    license.append("  It may happen that this requirement contradicts the license\n");
    license.append("restrictions of other proprietary libraries that do not normally\n");
    license.append("accompany the operating system.  Such a contradiction means you cannot\n");
    license.append("use both them and the Library together in an executable that you\n");
    license.append("distribute.\n");
    license.append("\n");
    license.append("  7. You may place library facilities that are a work based on the\n");
    license.append("Library side-by-side in a single library together with other library\n");
    license.append("facilities not covered by this License, and distribute such a combined\n");
    license.append("library, provided that the separate distribution of the work based on\n");
    license.append("the Library and of the other library facilities is otherwise\n");
    license.append("permitted, and provided that you do these two things:\n");
    license.append("\n");
    license.append("    a) Accompany the combined library with a copy of the same work\n");
    license.append("    based on the Library, uncombined with any other library\n");
    license.append("    facilities.  This must be distributed under the terms of the\n");
    license.append("    Sections above.\n");
    license.append("\n");
    license.append("    b) Give prominent notice with the combined library of the fact\n");
    license.append("    that part of it is a work based on the Library, and explaining\n");
    license.append("    where to find the accompanying uncombined form of the same work.\n");
    license.append("\n");
    license.append("  8. You may not copy, modify, sublicense, link with, or distribute\n");
    license.append("the Library except as expressly provided under this License.  Any\n");
    license.append("attempt otherwise to copy, modify, sublicense, link with, or\n");
    license.append("distribute the Library is void, and will automatically terminate your\n");
    license.append("rights under this License.  However, parties who have received copies,\n");
    license.append("or rights, from you under this License will not have their licenses\n");
    license.append("terminated so long as such parties remain in full compliance.\n");
    license.append("\n");
    license.append("  9. You are not required to accept this License, since you have not\n");
    license.append("signed it.  However, nothing else grants you permission to modify or\n");
    license.append("distribute the Library or its derivative works.  These actions are\n");
    license.append("prohibited by law if you do not accept this License.  Therefore, by\n");
    license.append("modifying or distributing the Library (or any work based on the\n");
    license.append("Library), you indicate your acceptance of this License to do so, and\n");
    license.append("all its terms and conditions for copying, distributing or modifying\n");
    license.append("the Library or works based on it.\n");
    license.append("\n");
    license.append("  10. Each time you redistribute the Library (or any work based on the\n");
    license.append("Library), the recipient automatically receives a license from the\n");
    license.append("original licensor to copy, distribute, link with or modify the Library\n");
    license.append("subject to these terms and conditions.  You may not impose any further\n");
    license.append("restrictions on the recipients' exercise of the rights granted herein.\n");
    license.append("You are not responsible for enforcing compliance by third parties with\n");
    license.append("this License.\n");
    license.append("\n");
    license.append("  11. If, as a consequence of a court judgment or allegation of patent\n");
    license.append("infringement or for any other reason (not limited to patent issues),\n");
    license.append("conditions are imposed on you (whether by court order, agreement or\n");
    license.append("otherwise) that contradict the conditions of this License, they do not\n");
    license.append("excuse you from the conditions of this License.  If you cannot\n");
    license.append("distribute so as to satisfy simultaneously your obligations under this\n");
    license.append("License and any other pertinent obligations, then as a consequence you\n");
    license.append("may not distribute the Library at all.  For example, if a patent\n");
    license.append("license would not permit royalty-free redistribution of the Library by\n");
    license.append("all those who receive copies directly or indirectly through you, then\n");
    license.append("the only way you could satisfy both it and this License would be to\n");
    license.append("refrain entirely from distribution of the Library.\n");
    license.append("\n");
    license.append("If any portion of this section is held invalid or unenforceable under any\n");
    license.append("particular circumstance, the balance of the section is intended to apply,\n");
    license.append("and the section as a whole is intended to apply in other circumstances.\n");
    license.append("\n");
    license.append("It is not the purpose of this section to induce you to infringe any\n");
    license.append("patents or other property right claims or to contest validity of any\n");
    license.append("such claims; this section has the sole purpose of protecting the\n");
    license.append("integrity of the free software distribution system which is\n");
    license.append("implemented by public license practices.  Many people have made\n");
    license.append("generous contributions to the wide range of software distributed\n");
    license.append("through that system in reliance on consistent application of that\n");
    license.append("system; it is up to the author/donor to decide if he or she is willing\n");
    license.append("to distribute software through any other system and a licensee cannot\n");
    license.append("impose that choice.\n");
    license.append("\n");
    license.append("This section is intended to make thoroughly clear what is believed to\n");
    license.append("be a consequence of the rest of this License.\n");
    license.append("\n");
    license.append("  12. If the distribution and/or use of the Library is restricted in\n");
    license.append("certain countries either by patents or by copyrighted interfaces, the\n");
    license.append("original copyright holder who places the Library under this License may add\n");
    license.append("an explicit geographical distribution limitation excluding those countries,\n");
    license.append("so that distribution is permitted only in or among countries not thus\n");
    license.append("excluded.  In such case, this License incorporates the limitation as if\n");
    license.append("written in the body of this License.\n");
    license.append("\n");
    license.append("  13. The Free Software Foundation may publish revised and/or new\n");
    license.append("versions of the Lesser General Public License from time to time.\n");
    license.append("Such new versions will be similar in spirit to the present version,\n");
    license.append("but may differ in detail to address new problems or concerns.\n");
    license.append("\n");
    license.append("Each version is given a distinguishing version number.  If the Library\n");
    license.append("specifies a version number of this License which applies to it and\n");
    license.append("\"any later version\", you have the option of following the terms and\n");
    license.append("conditions either of that version or of any later version published by\n");
    license.append("the Free Software Foundation.  If the Library does not specify a\n");
    license.append("license version number, you may choose any version ever published by\n");
    license.append("the Free Software Foundation.\n");
    license.append("\n");
    license.append("  14. If you wish to incorporate parts of the Library into other free\n");
    license.append("programs whose distribution conditions are incompatible with these,\n");
    license.append("write to the author to ask for permission.  For software which is\n");
    license.append("copyrighted by the Free Software Foundation, write to the Free\n");
    license.append("Software Foundation; we sometimes make exceptions for this.  Our\n");
    license.append("decision will be guided by the two goals of preserving the free status\n");
    license.append("of all derivatives of our free software and of promoting the sharing\n");
    license.append("and reuse of software generally.\n");
    license.append("\n");
    license.append("			    NO WARRANTY\n");
    license.append("\n");
    license.append("  15. BECAUSE THE LIBRARY IS LICENSED FREE OF CHARGE, THERE IS NO\n");
    license.append("WARRANTY FOR THE LIBRARY, TO THE EXTENT PERMITTED BY APPLICABLE LAW.\n");
    license.append("EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR\n");
    license.append("OTHER PARTIES PROVIDE THE LIBRARY \"AS IS\" WITHOUT WARRANTY OF ANY\n");
    license.append("KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE\n");
    license.append("IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR\n");
    license.append("PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE\n");
    license.append("LIBRARY IS WITH YOU.  SHOULD THE LIBRARY PROVE DEFECTIVE, YOU ASSUME\n");
    license.append("THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.\n");
    license.append("\n");
    license.append("  16. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN\n");
    license.append("WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY\n");
    license.append("AND/OR REDISTRIBUTE THE LIBRARY AS PERMITTED ABOVE, BE LIABLE TO YOU\n");
    license.append("FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR\n");
    license.append("CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE\n");
    license.append("LIBRARY (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING\n");
    license.append("RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A\n");
    license.append("FAILURE OF THE LIBRARY TO OPERATE WITH ANY OTHER SOFTWARE), EVEN IF\n");
    license.append("SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH\n");
    license.append("DAMAGES.\n");
    license.append("\n");
    license.append("		     END OF TERMS AND CONDITIONS\n");
    license.append("\n");
    license.append("           How to Apply These Terms to Your New Libraries\n");
    license.append("\n");
    license.append("  If you develop a new library, and you want it to be of the greatest\n");
    license.append("possible use to the public, we recommend making it free software that\n");
    license.append("everyone can redistribute and change.  You can do so by permitting\n");
    license.append("redistribution under these terms (or, alternatively, under the terms of the\n");
    license.append("ordinary General Public License).\n");
    license.append("\n");
    license.append("  To apply these terms, attach the following notices to the library.  It is\n");
    license.append("safest to attach them to the start of each source file to most effectively\n");
    license.append("convey the exclusion of warranty; and each file should have at least the\n");
    license.append("\"copyright\" line and a pointer to where the full notice is found.\n");
    license.append("\n");
    license.append("    <one line to give the library's name and a brief idea of what it does.>\n");
    license.append("    Copyright (C) <year>  <name of author>\n");
    license.append("\n");
    license.append("    This library is free software; you can redistribute it and/or\n");
    license.append("    modify it under the terms of the GNU Lesser General Public\n");
    license.append("    License as published by the Free Software Foundation; either\n");
    license.append("    version 2.1 of the License, or (at your option) any later version.\n");
    license.append("\n");
    license.append("    This library is distributed in the hope that it will be useful,\n");
    license.append("    but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
    license.append("    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU\n");
    license.append("    Lesser General Public License for more details.\n");
    license.append("\n");
    license.append("    You should have received a copy of the GNU Lesser General Public\n");
    license.append("    License along with this library; if not, write to the Free Software\n");
    license.append("    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n");
    license.append("\n");
    license.append("Also add information on how to contact you by electronic and paper mail.\n");
    license.append("\n");
    license.append("You should also get your employer (if you work as a programmer) or your\n");
    license.append("school, if any, to sign a \"copyright disclaimer\" for the library, if\n");
    license.append("necessary.  Here is a sample; alter the names:\n");
    license.append("\n");
    license.append("  Yoyodyne, Inc., hereby disclaims all copyright interest in the\n");
    license.append("  library `Frob' (a library for tweaking knobs) written by James Random Hacker.\n");
    license.append("\n");
    license.append("  <signature of Ty Coon>, 1 April 1990\n");
    license.append("  Ty Coon, President of Vice\n");
    license.append("\n");
    license.append("That's all there is to it!\n");
    LICENSE = license.toString();
    StringBuffer about = new StringBuffer(16384);
    about.append("Archis Cellular Artificial Life Simulator\n");
    about.append("(c)2001-2003 Adam Ierymenko, all rights reserved.\n");
    about.append("Distributed under the terms of the GNU LGPL (see other tab)\n");
    about.append("\n");
    about.append("Archis is a general, extendable, networkable platform for\n");
    about.append("cellular-type artificial life simulations.  Visit the Archis\n");
    about.append("homepage at:\n");
    about.append("\n");
    about.append("http://www.generalnegentropics.com/archis/\n");
    about.append("\n");
    about.append("If you enjoy this program, you are encouraged to make a donation\n");
    about.append("of any amount (visit the homepage for a link). This will encourage\n");
    about.append("and support the further development of Archis and perhaps other\n");
    about.append("similar things as well!\n");
    ABOUT = about.toString();
  }

  private JPanel contentPane;
  private TitledBorder titledBorder1;
  private BorderLayout borderLayout1 = new BorderLayout();
  private JTabbedPane jTabbedPane1 = new JTabbedPane();
  private JPanel jPanel1 = new JPanel();
  private JPanel jPanel2 = new JPanel();
  private JButton jButton1 = new JButton();
  private BorderLayout borderLayout2 = new BorderLayout();
  private BorderLayout borderLayout3 = new BorderLayout();
  private JScrollPane jScrollPane1 = new JScrollPane();
  private JScrollPane jScrollPane2 = new JScrollPane();
  private JTextArea aboutTextArea = new JTextArea();
  private JTextArea licenseTextArea = new JTextArea();

  public AboutBox() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    this.setSize(600,350);
    Dimension ss = this.getToolkit().getScreenSize();
    this.setLocation((ss.width/2)-(this.getWidth()/2),(ss.height/2)-(this.getHeight()/2));
    this.setIconImage(Archis.ICON);
    licenseTextArea.setText(LICENSE);
    licenseTextArea.setCaretPosition(0);
    aboutTextArea.setText(ABOUT);
    aboutTextArea.setCaretPosition(0);
  }
  private void jbInit() throws Exception {
    contentPane = (JPanel)this.getContentPane();
    titledBorder1 = new TitledBorder("");
    this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
    this.setResizable(false);
    this.setTitle("About Archis");
    contentPane.setBorder(BorderFactory.createLineBorder(Color.black));
    contentPane.setLayout(borderLayout1);
    jButton1.setText("Close");
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton1_actionPerformed(e);
      }
    });
    jPanel1.setLayout(borderLayout2);
    jPanel2.setLayout(borderLayout3);
    aboutTextArea.setBackground(Color.black);
    aboutTextArea.setFont(new java.awt.Font("Dialog", 0, 14));
    aboutTextArea.setForeground(Color.orange);
    aboutTextArea.setCaretColor(Color.orange);
    aboutTextArea.setEditable(false);
    aboutTextArea.setSelectedTextColor(Color.orange);
    aboutTextArea.setSelectionColor(Color.darkGray);
    licenseTextArea.setBackground(Color.black);
    licenseTextArea.setFont(new java.awt.Font("Dialog", 0, 12));
    licenseTextArea.setForeground(Color.orange);
    licenseTextArea.setCaretColor(Color.orange);
    licenseTextArea.setEditable(false);
    licenseTextArea.setSelectedTextColor(Color.orange);
    licenseTextArea.setSelectionColor(Color.darkGray);
    jScrollPane2.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
    jScrollPane2.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    jScrollPane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
    jScrollPane1.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    contentPane.add(jTabbedPane1,  BorderLayout.CENTER);
    jTabbedPane1.add(jPanel1,   "About Archis");
    jPanel1.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(aboutTextArea, null);
    jTabbedPane1.add(jPanel2,   "License (LGPL)");
    jPanel2.add(jScrollPane2, BorderLayout.CENTER);
    jScrollPane2.getViewport().add(licenseTextArea, null);
    contentPane.add(jButton1,  BorderLayout.SOUTH);
  }

  void jButton1_actionPerformed(ActionEvent e) {
    this.setVisible(false);
    this.dispose();
  }
}

